<?php
/*
Plugin Name: Worthless Plugin
Plugin URI: http://www.arnan.me/?pk_campaign=worthlessplugin&pk_kwd=plugin-url
Author: Arnan de Gans
Author URI: http://www.arnan.me/?pk_campaign=worthlessplugin&pk_kwd=author-url
Description: A worthless plugin doing worthless things.
Text Domain: ajdg-worthless
Domain Path: /
Version: 2.1
License: GPL
*/ 

#---------------------------------------------------
# Load plugin and values
#---------------------------------------------------
register_activation_hook(__FILE__, 'worthless_activate');
register_deactivation_hook(__FILE__, 'worthless_deactivate');
load_plugin_textdomain('ajdg-worthless', false, basename(dirname(__FILE__)).'/language');
worthless_check_config();

add_action('wp_footer', 'worthless_undertaker', 101);
add_action('admin_menu', 'worthless_dashboard');
add_action("admin_print_styles", 'worthless_dashboard_styles');
add_filter('plugin_action_links_' . plugin_basename( __FILE__ ), 'worthless_action_links');

if(isset($_POST['worthless_submit_options'])) {
	add_action('init', 'worthless_options_submit');
}

$worthless_config = get_option('worthless_config');

/*-------------------------------------------------------------
 Name:      worthless_dashboard

 Purpose:   Dashboard pages
 Receive:   -none-
 Return:    -none-
-------------------------------------------------------------*/
function worthless_dashboard() {
	add_submenu_page('options-general.php', 'Worthless Plugin', 'Worthless Plugin', 'manage_options', 'worthlessplugin', 'worthless_dashboard_options');
}

/*-------------------------------------------------------------
 Name:      worthless_options_page

 Purpose:   Admin options page
 Receive:   -none-
 Return:    -none-
-------------------------------------------------------------*/
function worthless_dashboard_options() {
	$worthless_config = get_option('worthless_config');
?>
	<div class="wrap">
		<h2><?php _e('Worthless Plugin', 'ajdg-worthless'); ?></h2>

		<div id="dashboard-widgets-wrap">
			<div id="dashboard-widgets" class="metabox-holder">
	
				<div id="postbox-container-1" class="postbox-container" style="width:50%;">
					<div id="normal-sortables" class="meta-box-sortables ui-sortable">
						
						<h3><?php _e('Support Worthless Plugin', 'ajdg-worthless'); ?></h3>
						<div class="postbox-ajdg">
							<div class="inside">
								<p><?php _e('Consider writing a review or making a donation if you like the plugin or if you find the plugin useful. Thanks for your support!', 'ajdg-worthless'); ?><br />
								<center><a class="button-primary" href="https://paypal.me/arnandegans/5usd" target="_blank">Donate $5 via Paypal</a> <a class="button" target="_blank" href="https://wordpress.org/support/plugin/worthless-plugin/reviews/?rate=5#new-post">Write review on WordPress.org</a></center><br />
								<a href="http://www.arnan.me/?pk_campaign=worthless-plugin&pk_kwd=banner" title="arnan.me - Nomadic in the Philippines"><img src="<?php echo plugins_url('/images/arnan-credits.jpg', __FILE__); ?>" alt="Arnan de Gans" align="center" class="ajdg-photo" width="100%" /></a></p>
								<script>(function(d, s, id) {
								  var js, fjs = d.getElementsByTagName(s)[0];
								  if (d.getElementById(id)) return;
								  js = d.createElement(s); js.id = id;
								  js.src = "https://connect.facebook.net/en_US/sdk.js#xfbml=1&version=v2.5";
								  fjs.parentNode.insertBefore(js, fjs);
								}(document, 'script', 'facebook-jssdk'));</script>
								<p><center><div class="fb-page" 
									data-href="https://www.facebook.com/Arnandegans" 
									data-width="490" 
									data-adapt-container-width="true" 
									data-hide-cover="false" 
									data-show-facepile="false">
								</div></center></p>
							</div>
						</div>
					</div>

					<div id="normal-sortables" class="meta-box-sortables ui-sortable">
						
						<h3><?php _e('Settings', 'ajdg-worthless'); ?></h3>
						<div class="postbox-ajdg">
							<div class="inside">
							  	<form method="post" action="<?php echo $_SERVER['REQUEST_URI'];?>">
								  	<?php wp_nonce_field('worthless_save','worthless_nonce'); ?>
							    	<input type="hidden" name="worthless_submit_options" value="true" />
						
									<p><?php _e('I have', 'ajdg-worthless'); ?> <select name="worthless_saved">
							     	   	<option value="10000" <?php if($worthless_config['saved'] == "10000") { echo 'selected'; } ?>>10000 or more</option>
								        <option value="5000" <?php if($worthless_config['saved'] == "5000") { echo 'selected'; } ?>>5000-9999</option>
								        <option value="3000" <?php if($worthless_config['saved'] == "3000") { echo 'selected'; } ?>>3000-4999</option>
								        <option value="1500" <?php if($worthless_config['saved'] == "1500") { echo 'selected'; } ?>>1500-2999</option>
								        <option value="1000" <?php if($worthless_config['saved'] == "1000") { echo 'selected'; } ?>>1000-1499</option>
								        <option value="500" <?php if($worthless_config['saved'] == "500") { echo 'selected'; } ?>>500-999</option>
								        <option value="300" <?php if($worthless_config['saved'] == "300") { echo 'selected'; } ?>>300-499 (default)</option>
								        <option value="100" <?php if($worthless_config['saved'] == "100") { echo 'selected'; } ?>>100-299</option>
								        <option value="1" <?php if($worthless_config['saved'] == "1") { echo 'selected'; } ?>>1-99</option>
									</select> <?php _e('visits on an average day!', 'ajdg-worthless'); ?></p>
						
							    	<p><strong><?php _e('Statistics', 'ajdg-worthless'); ?></strong><br />	    	
									<?php _e('Required hits:', 'ajdg-worthless'); ?> <?php echo $worthless_config['event']; ?><br />
									<?php _e('Current hits:', 'ajdg-worthless'); ?> <?php echo $worthless_config['current']; ?><br />
									<?php _e('Events logged:', 'ajdg-worthless'); ?> <?php echo $worthless_config['logged']; ?></p>
						
									<p class="submit">
										<input type="submit" name="Submit" class="button-primary" value="<?php _e('Save Changes', 'ajdg-worthless'); ?>" />
									</p>
								</form>
							</div>
						</div>
					</div>
				</div>
	
				<div id="postbox-container-3" class="postbox-container" style="width:50%;">
					<div id="side-sortables" class="meta-box-sortables ui-sortable">
								
						<h3><?php _e('Worthless Plugin is brought to you by', 'ajdg-worthless'); ?></h3>
						<div class="postbox-ajdg">
							<div class="inside">
								<?php wp_widget_rss_output(array(
									'url' => array('http://www.arnan.me/feed/', 'http://ajdg.solutions/feed/'), 
									'items' => 5, 
									'show_summary' => 1, 
									'show_author' => 0, 
									'show_date' => 1)
								); ?>
							</div>
						</div>
		
					</div>	
				</div>
			</div>
		</div>
	</div>
<?php
}	

/*-------------------------------------------------------------
 Name:      worthless_action_links
 Purpose:	Plugin page link
 Since:		1.0
-------------------------------------------------------------*/
function worthless_action_links($links) {
	$custom_actions = array();
	$custom_actions['worthless'] = sprintf('<a href="%s" target="_blank">%s</a>', 'http://www.arnan.me/?pk_campaign=worthless-plugin&pk_kwd=action-url', 'Support');

	return array_merge($custom_actions, $links);
}

/*-------------------------------------------------------------
 Name:      worthless_dashboard_styles
 Purpose: 	Add security field to comment form
 Since:		1.0
-------------------------------------------------------------*/
function worthless_dashboard_styles() {
	wp_enqueue_style('ajdg-worthless-admin-stylesheet', plugins_url('library/dashboard.css', __FILE__));
}

/* -------------------------------------------------------------
 Name:      worthless_undertaker

 Purpose:   Add some spice to the website by running semi random
 			quota doing absolutely nothing worth mentioning. 
 Receive:   -none-
 Return:	-none-
------------------------------------------------------------- */
function worthless_undertaker() {
	global $worthless_config;
	
	$saved		= $worthless_config['saved'];
	$event		= $worthless_config['event'];
	$logged 	= $worthless_config['logged'];
	$current 	= $worthless_config['current'];

	$option['saved'] = $saved;
	if($current >= $event) {
		// A number match! Make an event happen!
		$option['event'] 	= worthless_random_seed($saved);
		$option['logged'] 	= $logged+1;
		$option['current']	= 0;
	} else {
		// Nothing to see, count a new hit
		$option['event'] 	= $event;
		$option['logged'] 	= $logged;
		$option['current'] 	= $current+1; 
	}

	update_option('worthless_config', $option);
}

/*-------------------------------------------------------------
 Name:      worthless_random_event

 Purpose:   Make it happen!
 Receive:   -none-
 Return:    -none-
-------------------------------------------------------------*/
function worthless_random_event($logged, $event) {
	global $worthless_config;
	
	$blogname = get_option('blogname');
	$email = get_option('admin_email');
	
	$subject = '[Worthless Action] This is a worthless notification';
	
	$message = "Hello,\r\n";
	$message .= "\r\n";
	$message .= "This worthless message is send to you from your blog '{$blogname}'.\r\n";
	$message .= "Your worthless quota has been reached {$worthless_config[logged]} times now and reset to a random worthless value!\r\n";
	$message .= "\r\n";
	$message .= "Have a nice day!\r\n";
	$message .= "http://www.arnan.me\r\n";
	
	wp_mail($email, $subject, $message);
}

/*-------------------------------------------------------------
 Name:      worthless_activate

 Purpose:   Activation script
 Receive:   -none-
 Return:    -none-
-------------------------------------------------------------*/
function worthless_activate() {
	// 42
}

/*-------------------------------------------------------------
 Name:      worthless_deactivate

 Purpose:   Deactivation script
 Receive:   -none-
 Return:    -none-
-------------------------------------------------------------*/
function worthless_deactivate() {
	delete_option('worthless_config');
}

/*-------------------------------------------------------------
 Name:      worthless_random_seed

 Purpose:   Generate a random seed!
 Receive:   $seed
 Return:    $random_seed
-------------------------------------------------------------*/
function worthless_random_seed($seed) {
	global $worthless_config;
	
	if($seed == 10000) $random_seed = $seed/2+rand(10000,15000)-$seed;
	if($seed == 5000) $random_seed = $seed/2+rand(5000,9999)-$seed;
	if($seed == 3000) $random_seed = $seed/2+rand(3000,4999)-$seed;
	if($seed == 1500) $random_seed = $seed/2+rand(1500,2999)-$seed;
	if($seed == 1000) $random_seed = $seed/2+rand(1000,1499)-$seed;
	if($seed == 500) $random_seed = $seed/2+rand(500,999)-$seed;
	if($seed == 300) $random_seed = $seed/2+rand(300,499)-$seed;
	if($seed == 100) $random_seed = $seed/2+rand(100,299)-$seed;
	if($seed == 1) $random_seed = $seed/2+rand(1,100)-$seed;

	$random_seed = floor($random_seed)*2;

	return $random_seed;
}

/*-------------------------------------------------------------
 Name:      worthless_check_config

 Purpose:   Create or update the options
 Receive:   -none-
 Return:    -none-
-------------------------------------------------------------*/
function worthless_check_config() {
	// Configuration
	if ( !$option = get_option('worthless_config') ) {
		// Default Options
		$option['saved'] 					= '300';
		$option['event'] 					= '300';
		$option['logged'] 					= '0';
		$option['current'] 					= '0';
		update_option('worthless_config', $option);
	}
}

/*-------------------------------------------------------------
 Name:      worthless_options_submit

 Purpose:   Save options
 Receive:   $_POST
 Return:    -none-
-------------------------------------------------------------*/
function worthless_options_submit() {
	if(wp_verify_nonce($_POST['worthless_nonce'], 'worthless_save')) {
		$buffer = get_option('worthless_config');
		$seed = $_POST['worthless_saved'];
		if(!is_numeric($seed)) $seed = 300;

		$option['saved']	 			= $seed;
		$option['event']	 			= worthless_random_seed($seed);
		$option['logged']	 			= $buffer['logged'];
		$option['current']	 			= $buffer['current'];
		update_option('worthless_config', $option);
	} else {
		echo '	<h2 style="text-align: center;">Oh no! Something went wrong!</h2>';
		echo '	<p style="text-align: center;">WordPress was unable to verify the authenticity of the url you have clicked. Verify if the url used is valid or log in via your browser.</p>';
		echo '	<p style="text-align: center;">If you have received the url you want to visit via email, you are being tricked!</p>';
		exit;
	}
}
?>